#!/usr/bin/env python
"""

Rules for building C/API module with f2py2e.

Copyright 1999,2000 Pearu Peterson all rights reserved,
Pearu Peterson <pearu@ioc.ee>          
Permission to use, modify, and distribute this software is given under the
terms of the LGPL.  See http://www.fsf.org

NO WARRANTY IS EXPRESSED OR IMPLIED.  USE AT YOUR OWN RISK.
$Date: 2001/12/04 13:42:09 $
Pearu Peterson
"""

__version__ = "$Revision: 1.4 $"[10:-1]

f2py_version='See `f2py -v`'

import pprint,copy
import sys,string,time,types,copy
errmess=sys.stderr.write
outmess=sys.stdout.write
show=pprint.pprint

from auxfuncs import *
def var2fixfortran(vars,a,fa=None):
    if fa is None:
        fa = a
    if not vars.has_key(a):
        show(vars)
        outmess('var2fixfortran: No definition for argument "%s".\n'%a)
        return ''
    if not vars[a].has_key('typespec'):
        show(vars[a])
        outmess('var2fixfortran: No typespec for argument "%s".\n'%a)
        return ''
    vardef=vars[a]['typespec']
    if vardef=='type' and vars[a].has_key('typename'):
        vardef='%s(%s)'%(vardef,vars[a]['typename'])
    selector={}
    if vars[a].has_key('kindselector'): selector=vars[a]['kindselector']
    elif vars[a].has_key('charselector'): selector=vars[a]['charselector']
    if selector.has_key('*'):
        if selector['*'] in ['*',':']:
            vardef='%s*(%s)'%(vardef,selector['*'])
        else:
            vardef='%s*%s'%(vardef,selector['*'])
    else:
        if selector.has_key('len'):
            vardef='%s(len=%s'%(vardef,selector['len'])
            if selector.has_key('kind'):
                vardef='%s,kind=%s)'%(vardef,selector['kind'])
            else:
                vardef='%s)'%(vardef)
        elif selector.has_key('kind'):
            vardef='%s(kind=%s)'%(vardef,selector['kind'])

    vardef='%s %s'%(vardef,fa)
    if vars[a].has_key('dimension'):
        vardef='%s(%s)'%(vardef,string.join(vars[a]['dimension'],','))
    return vardef
def createfuncwrapper(rout):
    ret = ['']
    def add(line,ret=ret):
        ret[0] = '%s\n      %s'%(ret[0],line)
    name = rout['name']
    fortranname = getfortranname (rout)
    newname = '%sf2pywrap'%(name)
    rout['args'][0] = newname
    vars = rout['vars']

    l = var2fixfortran(vars,name,fortranname)
    if l[:13]=='character*(*)':
        l = 'character*10'+l[13:]
    if ismoduleroutine(rout):
        add('subroutine f2pywrap_%s_%s (%s)'%(rout['modulename'],name,string.join(rout['args'],', ')))
        add('use %s'%(rout['modulename']))
        l = l[:len(l)-len(name)] + newname 
    else:
        add('subroutine f2pywrap%s (%s)'%(name,string.join(rout['args'],', ')))
        add('external %s'%(fortranname))
        l = l + ', '+newname
    add(l)
    vars[newname] = vars[name]
    for a in rout['args'][1:]:
        if isexternal(vars[a]):
            add('external %s'%(a))
            continue
        add(var2fixfortran(vars,a))
    add('%s = %s(%s)'%(newname,fortranname,string.join(rout['args'][1:],', ')))
    if ismoduleroutine(rout):
        add('end subroutine f2pywrap_%s_%s'%(rout['modulename'],name))
    else:
        add('end')
    rout['args'][0] = name
    return ret[0]

def assubr(rout):
    if not isfunction_wrap(rout): return rout,''
    fortranname = getfortranname(rout)
    name = rout['name']
    outmess('\t\tCreating wrapper for Fortran function "%s"("%s")...\n'%(name,fortranname))
    rout = copy.copy(rout)
    fname = name
    rname = fname
    if rout.has_key('result'):
        rname = rout['result']
        rout['vars'][fname]=rout['vars'][rname]
    fvar = rout['vars'][fname]
    if not isintent_out(fvar):
        if not fvar.has_key('intent'): fvar['intent']=[]
        fvar['intent'].append('out')
    rout['args'] = [fname] + rout['args']
    return rout,createfuncwrapper(rout)
